<?php
/***********************************
  Coppermine 1.6.x New reCAPTCHA plugin v1.0 BETA 
  **********************************
  By: Joe Carver based on CPG 1.4.x version by SaWey (Sander Weyens)
  Date: 2022-11-29
***********************************/

	if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

	global $CONFIG, $CPG_PHP_SELF;
	define('RECAPTCHAPATH', $thisplugin->fullpath);
	require ("./plugins/recaptcha/lang/english.php");	
	// Add install & configure action
	$thisplugin->add_action('plugin_install','new_recaptcha_install');
	$thisplugin->add_action('plugin_configure','new_recaptcha_configure');
	$thisplugin->add_action('plugin_uninstall','new_recaptcha_uninstall');

	// Add filters & actions to display & validate CAPTCHA
	$thisplugin->add_filter('captcha_comment_print', 'add_captcha_comment');
	$thisplugin->add_filter('captcha_contact_print', 'add_captcha_contact');
	$thisplugin->add_filter('captcha_register_print', 'add_captcha_register');
	$thisplugin->add_filter('captcha_ecard_print', 'add_captcha_ecard');
	$thisplugin->add_filter('captcha_register_validate', 'validate_register');
	$thisplugin->add_action('captcha_comment_validate', 'validate_comment');
	$thisplugin->add_action('captcha_contact_validate', 'validate_contact');
	$thisplugin->add_action('captcha_ecard_validate', 'validate_ecard');
	
	// Add filter for remote recaptcha .js to page meta only on pages that need it
	$recaptcha_pages_array = array('displayimage.php', 'register.php', 'contact.php', 'ecard.php');
	if (in_array($CPG_PHP_SELF, $recaptcha_pages_array) == TRUE) {
	$thisplugin->add_filter('page_meta','recaptcha_header');
	function recaptcha_header($html) {
	global $CONFIG, $template_header; //$LINEBREAK
	//$recapt_lang = $CONFIG['new_recaptcha_lang'];
	$meta = <<< EOT

<!-- New reCaptcha plugin for Coppermine 1.6 v1.0 by SaWey and Carver -->
<script src='https://www.google.com/recaptcha/api.js'></script>
<!-- reCaptcha plugin end -->
EOT;
	return $html . $meta;
    }	
	}

//show the comment captcha
	function add_captcha_comment($template){
	global $CONFIG, $lang_common;
	if (($CONFIG['comment_captcha'] == 1) || ($CONFIG['comment_captcha'] == 2 && !USER_ID)) {	
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	//load language
	$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
	include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');		
	$key_public = $CONFIG['new_recaptcha_key'];
	
	$captcha_html = <<< EOT
	<div class="g-recaptcha" data-sitekey="{$key_public}"></div>
EOT;
	
	$new_template = <<< EOT
	<tr>
		<td class="tableb" colspan="3">
		  {CONFIRM}
		</td>
		<td class="tableb" colspan="3">
		  <div id="captcha_div">{$captcha_html}</div>
		</td>
	</tr>
EOT;

	$pattern = "#(<!-- BEGIN comment_captcha -->)(.*?)(<!-- END comment_captcha -->)#s";
	if ( !preg_match($pattern, $template, $matches)) {
			die('<strong>Template error<strong><br />Failed to find block \''.$block_name.'\'('.htmlspecialchars($pattern).') in :<br /><pre>'.htmlspecialchars($template).'</pre>');
	}
	
	$template = str_replace($matches[1].$matches[2].$matches[3], $new_template, $template);
	return $template;
	}
	}


// Contact captcha html
function add_captcha_contact($captcha_print){
	global $CONFIG, $lang_common, $captcha_remark, $expand_array;
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	//load language
	$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
	include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');	
	
	$visibility = isset($expand_array['captcha_remark']) ? 'block' : 'none';
	
	$key_public = $CONFIG['new_recaptcha_key'];
	//$recapt_style = $CONFIG['new_recaptcha_style'];;
	//$recapt_lang = $CONFIG['new_recaptcha_lang'];	

	/*$contact_instruct = '';
	if ($CONFIG['new_recaptcha_contacthelp'] == 1)  {
	$contact_instruct = $recap_lang['contact_instruct'];
	}*/	
	
	$captcha_html = <<< EOT
	<div class="g-recaptcha" data-sitekey="{$key_public}"></div>
EOT;
	
	$captcha_print = <<< EOT
    <tr>
      <td class="tableb" valign="top" align="right">
        {$lang_common['confirm']}
      </td>
      <td class="tableb" valign="top">
        {$captcha_html}
      </td>
	  <td class="tableb">
        <span id="captcha_remark" style="display:{$visibility}">{$captcha_remark}</span>
      </td>
    </tr>
EOT;
	return $captcha_print;
}

// recaptcha html for register.php
function add_captcha_register($captcha_print){
	global $CONFIG, $lang_common;
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	
	//load language
	$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
	include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');
	
	$key_public = $CONFIG['new_recaptcha_key'];
	$captcha_html = <<< EOT
	<div class="g-recaptcha" data-sitekey="{$key_public}"></div>
EOT;
	
	$captcha_print = <<< EOT
    <tr>
      <td class="tableb" valign="top" align="right">
        {$lang_common['confirm']}
      </td>
      <td class="tableb" valign="top">
        {$captcha_html}
      </td>
    </tr>
EOT;
	return $captcha_print;
}

// recaptcha html for ecard.php
function add_captcha_ecard($captcha_print){
	global $CONFIG, $lang_common;
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	
	//load language
	$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
	include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');
	
	$key_public = $CONFIG['new_recaptcha_key'];
	$captcha_html = <<< EOT
	<div class="g-recaptcha" data-sitekey="{$key_public}"></div>
EOT;
	
	$captcha_print = <<< EOT
    <tr>
      <td class="tableb" valign="top" align="right">
        {$lang_common['confirm']}
      </td>
      <td class="tableb" valign="top">
        {$captcha_html}
      </td>
    </tr>
EOT;
	return $captcha_print;
}
/** END HTML CHANGES FOR CAPTCHA DISPLAY **/

/** START CAPTCHA VALIDATE **/

//validate captcha entry Comment
	function validate_comment(){ // shrink validation to single function -> different language and error responses 
	global $CONFIG, $USER_DATA, $hdr_ip;
	$superCage = Inspekt::makeSuperCage();
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	$secret = $CONFIG['new_recaptcha_privkey'];
	// Get validation info
	$post_data = "secret=$secret&response=".$superCage->post->getRaw('g-recaptcha-response')."&remoteip=".$superCage->server->getRaw('REMOTE_ADDR') ;
	// start curl
	$ch = curl_init();  
	curl_setopt($ch, CURLOPT_URL, "https://www.google.com/recaptcha/api/siteverify");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, 
	array('Content-Type: application/x-www-form-urlencoded; charset=utf-8', 'Content-Length: ' . strlen($post_data)));
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data); 
	$googresp = curl_exec($ch);       
	$decgoogresp = json_decode($googresp);
	curl_close($ch);	
	// good or bad?
	if (!($decgoogresp->success == true)) {
		if ($CONFIG['log_mode'] != 0) {
		log_write('Captcha authentication for Comment failed for user '.$USER_DATA['user_name'].' at ' . $hdr_ip, CPG_SECURITY_LOG);
		}
		//load language
		$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
		include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');
		cpg_die(ERROR, $recap_lang['incorrect-captcha-comment'], __FILE__, __LINE__);
		}	
	}

//validate captcha entry Contact
function validate_contact(){
	global $CONFIG, $USER_DATA, $hdr_ip;
	$superCage = Inspekt::makeSuperCage();
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	$secret = $CONFIG['new_recaptcha_privkey'];
	// Get validation info
	$post_data = "secret=$secret&response=".$superCage->post->getRaw('g-recaptcha-response')."&remoteip=".$superCage->server->getRaw('REMOTE_ADDR') ;
	// start curl
	$ch = curl_init();  
	curl_setopt($ch, CURLOPT_URL, "https://www.google.com/recaptcha/api/siteverify");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, 
	array('Content-Type: application/x-www-form-urlencoded; charset=utf-8', 'Content-Length: ' . strlen($post_data)));
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data); 
	$googresp = curl_exec($ch);       
	$decgoogresp = json_decode($googresp);
	curl_close($ch);	
	// good or bad?
	if (!($decgoogresp->success == true)) {
		if ($CONFIG['log_mode'] != 0) {
		log_write('Captcha authentication for Contact failed for user '.$USER_DATA['user_name'].' at ' . $hdr_ip, CPG_SECURITY_LOG);
		}
		$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';	//load language
		include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');
		cpg_die(ERROR, $recap_lang['incorrect-captcha-comment'], __FILE__, __LINE__);
	}
	}

//validate captcha entry Register
	function validate_register($error){
	global $CONFIG, $USER_DATA, $hdr_ip;
	$superCage = Inspekt::makeSuperCage();
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	$secret = $CONFIG['new_recaptcha_privkey'];
	// Get validation info
	$post_data = "secret=$secret&response=".$superCage->post->getRaw('g-recaptcha-response')."&remoteip=".$superCage->server->getRaw('REMOTE_ADDR') ;
	// start curl
	$ch = curl_init();  
	curl_setopt($ch, CURLOPT_URL, "https://www.google.com/recaptcha/api/siteverify");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, 
	array('Content-Type: application/x-www-form-urlencoded; charset=utf-8', 'Content-Length: ' . strlen($post_data)));
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data); 
	$googresp = curl_exec($ch);       
	$decgoogresp = json_decode($googresp);
	curl_close($ch);	
	// good or bad?
	if (!($decgoogresp->success == true)) {
		if ($CONFIG['log_mode'] != 0) {
		log_write('Captcha authentication for Register failed for user '.$USER_DATA['user_name'].' at ' . $hdr_ip, CPG_SECURITY_LOG);
		}
		//load language		
		$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
		include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');
		$error .= '<li style="list-style-image:url(images/icons/stop.png)">' . $recap_lang['incorrect-captcha-reg'] . '</li>';
	}
	return $error;
	}

// validate captcha entry ecard
function validate_ecard(){
	global $CONFIG, $USER_DATA, $hdr_ip;
	$superCage = Inspekt::makeSuperCage();
	require_once(RECAPTCHAPATH . '/recaptchalib.php');
	$secret = $CONFIG['new_recaptcha_privkey'];
	// Get validation info
	$post_data = "secret=$secret&response=".$superCage->post->getRaw('g-recaptcha-response')."&remoteip=".$superCage->server->getRaw('REMOTE_ADDR') ;
	// start curl
	$ch = curl_init();  
	curl_setopt($ch, CURLOPT_URL, "https://www.google.com/recaptcha/api/siteverify");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, 
	array('Content-Type: application/x-www-form-urlencoded; charset=utf-8', 'Content-Length: ' . strlen($post_data)));
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data); 
	$googresp = curl_exec($ch);       
	$decgoogresp = json_decode($googresp);
	curl_close($ch);	
	// good or bad?
	if (!($decgoogresp->success == true)) {
        if ($CONFIG['log_mode'] != 0) {
            log_write('Captcha authentication for ecard failed for user '.$USER_DATA['user_name'].' at ' . $hdr_ip, CPG_SECURITY_LOG);
        }
		//load language
		$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
		include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');
		cpg_die(ERROR, $recap_lang['incorrect-captcha-comment'], __FILE__, __LINE__);
	}
}
/*** END CAPTCHA VALIDATE ***/

/*** INSTALL / UNINSTALL ***/
// Install function
function new_recaptcha_install() {
	global $CONFIG;
	// Create the super cage
	$superCage = Inspekt::makeSuperCage();
	if (!$superCage->post->keyExists('rc_submit')) {
		return 1;
	}else{
		//create a new entry in the configuration table
		$rc_key = $superCage->post->getRaw('rc_key'); //needs sanitisation, but don't know which chars are currently allowed in the key
		$rc_privkey = $superCage->post->getRaw('rc_privkey');
		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_key', '$rc_key')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_privkey', '$rc_privkey')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_commenthelp', '0')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_reghelp', '1')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_contacthelp', '1')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_ecardhelp', '1')");		
		// ADD LANGUAGEcpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_ecardhelp', '1')");		
		// ADD STYLE??? cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('new_recaptcha_ecardhelp', '1')");		
		// activate ecard captcha option
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('ecard_captcha', '2')");		
		
	return true;
	}
}

// Display the installation form
	function new_recaptcha_configure() {
	global $CONFIG, $lang_common;
	// Create the super cage
	$superCage = Inspekt::makeSuperCage();
	
	//load language
	$file_lang = RECAPTCHAPATH . '/lang/' . $CONFIG['lang'] . '.php';
	include(file_exists($file_lang) ? $file_lang : RECAPTCHAPATH . '/lang/english.php');
	include_once(RECAPTCHAPATH . '/recaptchalib.php');
	$superCage = Inspekt::makeSuperCage();
	
	$action_uri = $superCage->server->getEscaped('REQUEST_URI');
    echo <<< EOT
    <form name="cpgform" id="cpgform" action="{$action_uri}" method="post">
            <table border="0" cellspacing="0" cellpadding="0" width="100%">
              <tr>
                <td class="tableh2" colspan="2">
                  <h2>{$recap_lang['install_explain']}</h2>
				  <br />
				  <a href="https://www.google.com/recaptcha/admin" rel="external">{$recap_lang['install_click']}</a>
				  <br />
                </td>
              </tr>
              <tr>
                <td class="tableb">
				<br />
                  {$recap_lang['recaptcha_key']}:
                </td>
			  </tr>
			  <tr>
                <td class="tableb">
                  <input type="text" name="rc_key" class="textinput" size="65"/>
                </td>
              </tr>
			  <tr>
                <td class="tableb">
				<br />
                  {$recap_lang['recaptcha_privkey']}:
                </td>
			  </tr>
			  <tr>
                <td class="tableb">
                  <input type="text" name="rc_privkey" class="textinput" size="65"/>
                </td>
              </tr>
              <tr>
                <td class="tablef" colspan="2">
                  <input type="submit" name="rc_submit" value="{$lang_common['go']}" />
                </td>
              </tr>
            </table>
    </form>
EOT;
}

// Uninstall
function new_recaptcha_uninstall(){
	global $CONFIG;
	//remove the record from config
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'new_recaptcha_key'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'new_recaptcha_privkey'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'new_recaptcha_commenthelp'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'new_recaptcha_reghelp'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'new_recaptcha_contacthelp'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'new_recaptcha_rows'");
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'new_recaptcha_ecardhelp'");
	// remove captcha option ecard   
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'ecard_captcha'");	
		
	return true;	
}

?>